package model.beans;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import saver.Savable;

public class Address implements Savable {
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((apartments == null) ? 0 : apartments.hashCode());
		result = prime * result + ((house == null) ? 0 : house.hashCode());
		result = prime * result + ((street == null) ? 0 : street.hashCode());
		result = prime * result + ((town == null) ? 0 : town.hashCode());
		return result;
	}
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Address other = (Address) obj;
		if (apartments == null) {
			if (other.apartments != null)
				return false;
		} else if (!apartments.equals(other.apartments))
			return false;
		if (house == null) {
			if (other.house != null)
				return false;
		} else if (!house.equals(other.house))
			return false;
		if (street == null) {
			if (other.street != null)
				return false;
		} else if (!street.equals(other.street))
			return false;
		if (town == null) {
			if (other.town != null)
				return false;
		} else if (!town.equals(other.town))
			return false;
		return true;
	}
	private String town;
	private String street;
	private Integer house;
	private Integer apartments;
	public String getTown() {
		return town;
	}
	public void setTown(String town) {
		this.town = town;
	}
	public String getStreet() {
		return street;
	}
	public void setStreet(String street) {
		this.street = street;
	}
	public Integer getHouse() {
		return house;
	}
	public void setHouse(Integer house) {
		this.house = house;
	}
	public Integer getApartments() {
		return apartments;
	}
	public void setApartments(Integer apartments) {
		this.apartments = apartments;
	}
	@Override
	public String toString() {
		return town + ", " + street + ", " + house + ", " + apartments;
	}
	public Address(String town, String street, Integer house, Integer apartments) {
		super();
		this.town = town;
		this.street = street;
		this.house = house;
		this.apartments = apartments;
	}
	public Address() {
		// TODO Auto-generated constructor stub
	}
	@Override
	public Element save(Document document) throws Exception {
		Element address = document.createElement("address");
		Element town = document.createElement("town");
		town.appendChild(document.createTextNode(this.town));
		address.appendChild(town);
		Element street = document.createElement("street");
		street.appendChild(document.createTextNode(this.street));
		address.appendChild(street);
		Element house = document.createElement("house");
		house.appendChild(document.createTextNode(this.house.toString()));
		address.appendChild(house);
		Element apartments = document.createElement("apartments");
		apartments.appendChild(document.createTextNode(this.apartments.toString()));
		address.appendChild(apartments);
		return address;
	}
	@Override
	public void load(Node node) throws Exception {
		if (node.getNodeName() == "address") {
			NodeList list = node.getChildNodes();
			this.town = list.item(0).getFirstChild().getTextContent();
			this.street = list.item(1).getFirstChild().getTextContent();
			this.house = Integer.parseInt(list.item(2).getFirstChild().getTextContent());
			this.apartments = Integer.parseInt(list.item(3).getFirstChild().getTextContent());
		}
	}
	public boolean isEmpty() {
		return (town == null || street == null || house == null || apartments == null);
	}
}
