package model.beans;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import saver.Savable;

public class FullName implements Savable {
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((name == null) ? 0 : name.hashCode());
		result = prime * result
				+ ((patronymic == null) ? 0 : patronymic.hashCode());
		result = prime * result + ((surname == null) ? 0 : surname.hashCode());
		return result;
	}
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		FullName other = (FullName) obj;
		if (name == null) {
			if (other.name != null)
				return false;
		} else if (!name.equals(other.name))
			return false;
		if (patronymic == null) {
			if (other.patronymic != null)
				return false;
		} else if (!patronymic.equals(other.patronymic))
			return false;
		if (surname == null) {
			if (other.surname != null)
				return false;
		} else if (!surname.equals(other.surname))
			return false;
		return true;
	}
	private String name;
	private String surname;
	private String patronymic;
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public String getSurname() {
		return surname;
	}
	public void setSurname(String surname) {
		this.surname = surname;
	}
	public String getPatronymic() {
		return patronymic;
	}
	public void setPatronymic(String patronymic) {
		this.patronymic = patronymic;
	}
	@Override
	public String toString() {
		return name + " " + surname + " " + patronymic;
	}
	public FullName(String name, String surname, String patronymic) {
		super();
		this.name = name;
		this.surname = surname;
		this.patronymic = patronymic;
	}
	public FullName() {
		// TODO Auto-generated constructor stub
	}
	@Override
	public Element save(Document document) throws Exception {
		Element fullName = document.createElement("fullName");
		Element name = document.createElement("name");
		name.appendChild(document.createTextNode(this.name));
		fullName.appendChild(name);
		Element surname = document.createElement("surname");
		surname.appendChild(document.createTextNode(this.surname));
		fullName.appendChild(surname);
		Element patronymic = document.createElement("patronymic");
		patronymic.appendChild(document.createTextNode(this.patronymic));
		fullName.appendChild(patronymic);
		return fullName;
	}
	@Override
	public void load(Node node) throws Exception {
		if (node.getNodeName() == "fullName") {
			NodeList list = node.getChildNodes();
			this.name = list.item(0).getFirstChild().getTextContent();
			this.surname = list.item(1).getFirstChild().getTextContent();
			this.patronymic = list.item(2).getFirstChild().getTextContent();
		}
	}
	
	public boolean isEmpty() {
		return (name == null || surname == null || patronymic == null);
	}

}
