package model.beans;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import saver.Savable;


public class Student implements Savable {
	
	private FullName fullName;
	private String sport;
	private String position;
	private String category;
	private Boolean memberInTeam;
	private Integer numberOfTitels;

	public FullName getFullName() {
		return fullName;
	}


	public Student(FullName fullName, String sport, String position,
			String category, Boolean memberInTeam, Integer numberOfTitels) {
		super();
		this.fullName = fullName;
		this.sport = sport;
		this.position = position;
		this.category = category;
		this.memberInTeam = memberInTeam;
		this.numberOfTitels = numberOfTitels;
	}


	public void setFullName(FullName fullName) {
		this.fullName = fullName;
	}


	public String getSport() {
		return sport;
	}


	public void setSport(String sport) {
		this.sport = sport;
	}


	public String getPosition() {
		return position;
	}


	public void setPosition(String position) {
		this.position = position;
	}


	public String getCategory() {
		return category;
	}


	public void setCategory(String category) {
		this.category = category;
	}


	public Boolean getMemberInTeam() {
		return memberInTeam;
	}


	public void setMemberInTeam(Boolean memberInTeam) {
		this.memberInTeam = memberInTeam;
	}


	public Integer getNumberOfTitels() {
		return numberOfTitels;
	}


	public void setNumberOfTitels(Integer numberOfTitels) {
		this.numberOfTitels = numberOfTitels;
	}


	public Student() {
	}
	
	
	public boolean isEmpty() {
		return (fullName == null || fullName.isEmpty() || sport == null || position == null || category == null|| memberInTeam == null || numberOfTitels == null);
	}

	@Override
	public Element save(Document document) throws Exception {
		Element student = document.createElement("student");
		Element fullName = this.fullName.save(document);
		student.appendChild(fullName);
		Element sport = document.createElement("sport");
		sport.appendChild(document.createTextNode(this.sport.toString()));
		student.appendChild(sport);
		Element position = document.createElement("position");
		position.appendChild(document.createTextNode(this.position.toString()));
		student.appendChild(position);
		Element category = document.createElement("category");
		category.appendChild(document.createTextNode(this.category.toString()));
		student.appendChild(category);
		Element memberInTeam = document.createElement("memberInTeam");
		memberInTeam.appendChild(document.createTextNode(this.memberInTeam.toString()));
		student.appendChild(memberInTeam);
		Element numberOfTitels = document.createElement("numberOfTitels");
		numberOfTitels.appendChild(document.createTextNode(this.numberOfTitels.toString()));
		student.appendChild(numberOfTitels);
		return student;
	}

	@Override
	public void load(Node node) throws Exception {
		if (node.getNodeName() == "student") {
			NodeList list = node.getChildNodes();
			this.fullName = new FullName();
			this.fullName.load(list.item(0));
			this.sport= list.item(1).getFirstChild().getTextContent();
			this.position = list.item(2).getFirstChild().getTextContent();
			this.category = list.item(3).getFirstChild().getTextContent();
			this.memberInTeam = Boolean.parseBoolean(list.item(4).getFirstChild().getTextContent());
			this.numberOfTitels = Integer.parseInt(list.item(5).getFirstChild().getTextContent());
		}
	}

}
