package view;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;

import view.components.JStudentAdder;
import controller.AddStudentController;

public class AddStudentView implements View {
	private AddStudentController controller;
	private JFrame frame;
	private JStudentAdder studentAdder;

	public AddStudentView(AddStudentController controller) {
		this.controller = controller;
		initFrame();
	}

	private void initFrame() {
		frame = new JFrame("Add your student...");
		frame.setLayout(new BorderLayout());
		frame.setSize(400, 400);
		frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		frame.setLocationRelativeTo(null);
		initElements();
	}

	private void initElements() {
		initStudentAdder();
		JButton okButton = new JButton("Add");
		okButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				try {
					controller.add(studentAdder.getName(),
							studentAdder.getSurname(),
							studentAdder.getPatronymic(),
							studentAdder.getSport(),
							studentAdder.getPosition(),
							studentAdder.getCategory(),
							studentAdder.getIsAMember(),
							studentAdder.getNumberOfTitels());
				} catch (Exception exception) {
					JOptionPane.showMessageDialog(frame, "Error!");
				}
			}
		});
		frame.add(okButton, BorderLayout.SOUTH);
	}

	private void initStudentAdder() {
		studentAdder = new JStudentAdder();
		frame.add(studentAdder, BorderLayout.CENTER);
	}

	@Override
	public void show() {
		frame.setVisible(true);
	}

}
