package view;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.JFileChooser;
import javax.swing.JFrame;

import controller.LoadController;

public class LoadView implements View{
	private JFrame loadFrame;
	private LoadController controller;
	public LoadView(LoadController controller) {
		this.controller = controller;
		initFrame();
	}
	private void initFrame() {
		loadFrame = new JFrame("Load");
		loadFrame.setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
		final JFileChooser fileChooser = new JFileChooser();
		fileChooser.setApproveButtonText("Load");
		fileChooser.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				File path = fileChooser.getSelectedFile();
				controller.load(path);
				loadFrame.setVisible(false);
			}
			
		});
		loadFrame.add(fileChooser);
		loadFrame.setSize(400, 400);
	}
	@Override
	public void show() {
		loadFrame.setVisible(true);
	}
	
}
