package view;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridLayout;

import javax.swing.JFrame;
import javax.swing.table.TableModel;

import view.components.JPageTable;
import controller.MainStudentController;

public class MainView implements View {
	public MainStudentController controller;
	public JFrame frame;
	public MainView(MainStudentController controller, TableModel model) {
		this.controller = controller;
		initFrame(model);
	}
	private void initFrame(TableModel model) {
		frame = new JFrame(" 2 ");
		frame.setLayout(new GridLayout(2, 1));
		frame.setSize(400, 600);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setMinimumSize(new Dimension(600,600));
		frame.setLocationRelativeTo(null);
		initElements(model);
	}
	private void initElements(TableModel model) {
		frame.setLayout(new BorderLayout());
		frame.add(new JPageTable(model), BorderLayout.CENTER);
		frame.setJMenuBar(new MyMenuBar(controller));
		
	}
	@Override
	public void show() {
		frame.setVisible(true);
	}

}
