package view;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;

import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.KeyStroke;

import controller.MainStudentController;

public class MyMenuBar extends JMenuBar {
	private JMenuItem openMenuItem;
	private JMenuItem saveMenuItem;
	private JMenuItem saveAsMenuItem;
	private JMenuItem exitMenuItem;
	private JMenuItem findMenuItem;
	private JMenuItem addMenuItem;
	public MainStudentController controller;


	public MyMenuBar(MainStudentController controller) {
		this.controller = controller;
		JMenu fileMenu = new JMenu("");
		add(fileMenu);
		openMenuItem = new JMenuItem("", KeyEvent.VK_O);
		openMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O,
				InputEvent.CTRL_MASK));
		openMenuItem.addActionListener(new MenuBarListener());
		fileMenu.add(openMenuItem);
		saveMenuItem = new JMenuItem("", KeyEvent.VK_S);
		saveMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,
				InputEvent.CTRL_MASK));
		saveMenuItem.addActionListener(new MenuBarListener());
		fileMenu.add(saveMenuItem);
		findMenuItem = new JMenuItem("", KeyEvent.VK_F);
		findMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,
				InputEvent.CTRL_MASK));
		findMenuItem.addActionListener(new MenuBarListener());
		fileMenu.add(findMenuItem);
		addMenuItem = new JMenuItem("", KeyEvent.VK_D);
		addMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,
				InputEvent.CTRL_MASK));
		addMenuItem.addActionListener(new MenuBarListener());
		fileMenu.add(addMenuItem);
		exitMenuItem = new JMenuItem("", KeyEvent.VK_E);
		exitMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_E,
				InputEvent.CTRL_MASK));
		exitMenuItem.addActionListener(new MenuBarListener());
		fileMenu.add(exitMenuItem);

	}

	private class MenuBarListener implements ActionListener {
		@Override
		public void actionPerformed(ActionEvent e) {
			String comStr = e.getActionCommand();
			if (comStr.equals(""))
				controller.runAddDialog();
			else if (comStr.equals(""))
				controller.runSearchDialog();
			else if (comStr.equals(""))
				controller.runSaveDialog();
			else if (comStr.equals(""))
				controller.runLoadDialog();
			else if (comStr.equals(""))
				System.exit(0);
		}
	}

}
