package view;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.JFileChooser;
import javax.swing.JFrame;

import controller.SaveController;

public class SaveView implements View{
	private JFrame saveFrame;
	private SaveController controller;
	public SaveView(SaveController controller) {
		this.controller = controller;
		initFrame();
	}
	private void initFrame() {
		saveFrame = new JFrame("Save");
		saveFrame.setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
		final JFileChooser fileChooser = new JFileChooser();
		fileChooser.setApproveButtonText("Save");
		fileChooser.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				File path = fileChooser.getSelectedFile();
				controller.save(path);
				saveFrame.setVisible(false);
			}
			
		});
		saveFrame.add(fileChooser);
		saveFrame.setSize(400, 400);
	}
	@Override
	public void show() {
		saveFrame.setVisible(true);
	}
	
}
