package Array;

import java.util.ArrayList;

public class Array {

    private Array() {
    };

    static public int[] randomlyArray(int n, int startInterval,
	    int finishInterval) {
	int[] array = new int[n];
	for (int i = 0; i < array.length; i++) {
	    array[i] = startInterval
		    + (int) (Math.random() * ((finishInterval - startInterval) + 1));
	}
	return array;
    }

    static public void directSorting(int[] array) {
	int i, j, value;
	for (i = 1; i < array.length; i++) {
	    value = array[i];
	    for (j = i - 1; j >= 0 && array[j] > value; j--) {
		array[j + 1] = array[j];
	    }
	    array[j + 1] = value;
	}
    }

    static public double directSortingWithTimer(int[] array) {
	long timeout = System.nanoTime();
	int i, j, value;
	for (i = 1; i < array.length; i++) {
	    value = array[i];
	    for (j = i - 1; j >= 0 && array[j] > value; j--) {
		array[j + 1] = array[j];
	    }
	    array[j + 1] = value;
	}
	timeout = System.nanoTime() - timeout;
	return new Long(timeout).doubleValue() / 1000;
    }

    static private double average(double[] time) {
	double[] temp = new double[time.length];
	for (int i = 0; i < time.length; i++) {
	    temp[i] = time[i] / time.length;
	}
	double suma = 0;
	for (int i = 0; i < temp.length; i++) {
	    suma = suma + temp[i];
	}
	return suma;
    }

    static public double testSort(int size, int startInterval,
	    int finishInterval) {
	int[] array = randomlyArray(size, startInterval, finishInterval);
	return directSortingWithTimer(array);
    }

    static public double testSortWithRepeat(int size, int repeat,
	    int startInterval, int finishInterval) {
	double[] time = new double[repeat];
	for (int i = 0; i < repeat; i++) {
	    time[i] = testSort(size, startInterval, finishInterval);
	}
	return average(time);
    }

    static public ArrayList<double[]> testsSort(int sizeStart, int sizeFinish,
	    int repeat, int startInterval, int finishInterval) {
	ArrayList<double[]> list = new ArrayList<double[]>();
	for (int n = sizeStart; n < sizeFinish; n++) {
	    double[] arrCheck = new double[2];
	    arrCheck[0] = n;
	    arrCheck[1] = testSortWithRepeat(n, repeat, startInterval,
		    finishInterval);
	    list.add(arrCheck);
	}
	return list;
    }

    static public double[] testsSortPoint(int size, int repeat,
	    int startInterval, int finishInterval) {
	double[] arrCheck = new double[2];
	arrCheck[0] = size;
	arrCheck[1] = testSortWithRepeat(size, repeat, startInterval,
		finishInterval);
	return arrCheck;
    }

    static public void print(int[] array) {
	for (int i = 0; i < array.length; i++) {
	    System.out.print(array[i] + " ");
	}
	System.out.println();
    }

    /*
     * static public void main(String argv[]) {
     * 
     * ArrayList<double[]> list = testsSort(2, 100, 5, -100, 100); for (int i =
     * 0; i < list.size(); i++) { System.out.println(list.get(i)[0] + " " +
     * list.get(i)[1]); }
     * 
     * }
     */

}
