package Veiwer;

import java.awt.BorderLayout;
import java.awt.Color;

import javax.swing.BorderFactory;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import Graph.GraphPanel;
import Model.GraphResultModel;

public class AdvancedGraphPanel extends JPanel {
    GraphPanel gp;
    GraphResultModel gpModel;
    JSlider stepSlider;

    public AdvancedGraphPanel(GraphResultModel gpModel) {
	this.gpModel = gpModel;
	setLayout(new BorderLayout());
	gp = new GraphPanel(gpModel);
	gp.setBorder(BorderFactory.createLineBorder(Color.GRAY, 2));
	stepSlider = new JSlider(-100, 100, 0);
	stepSlider.setMajorTickSpacing(10);
	stepSlider.setMinorTickSpacing(5);
	stepSlider.setLabelTable(stepSlider.createStandardLabels(10));
	stepSlider.setPaintTicks(true);
	stepSlider.setPaintLabels(true);
	add(gp, BorderLayout.CENTER);
	add(stepSlider, BorderLayout.SOUTH);
	stepSlider.addChangeListener(new ChangeListener() {
	    @Override
	    public void stateChanged(ChangeEvent e) {
		Integer step = stepSlider.getValue();
		if (step == 0)
		    gp.setValueOfDivisionX(gp.getValueOfDivisionY());
		else if (step > 0)
		    gp.setValueOfDivisionX(gp.getValueOfDivisionY() * step);
		else if (step < 0)
		    gp.setValueOfDivisionY(gp.getValueOfDivisionX()
			    * Math.abs(step));
	    }
	});
    }
}
