package Calculator;

import java.util.ArrayList;
import java.util.Stack;

public class Calculator {

	private static final String[] znak = { "+", "-", "*", "/", "^", "!", "@",
			"$", "#" };
	private static final String[] binznak = { "!", "@", "#" };

	private static final String[] digit = { "1", "2", "3", "4", "5", "6", "7",
			"8", "9", "0","." };

	static String serchBinMinus(String expression) {
		String modExpression = new String(expression);
		for (int i = 0; i < modExpression.length(); i++) {
			Character ss = modExpression.charAt(i);
			if (ss.equals('-') && i != 0) {
				Character sh = modExpression.charAt(i - 1);
				if (sh.equals('(') || isZnak(sh.toString()))
					modExpression = AdvancedString.replaceCharAt(modExpression,
							i, '#');
			} else if ((ss.equals('-')) && (i == 0)) {
				modExpression = AdvancedString.replaceCharAt(modExpression, i,
						'#');
			}

		}
		return modExpression;
	}

	static String serchDoubleZapis(String expression) {
		String modExpression = new String(expression);
		for (int i = 0; i < modExpression.length(); i++) {
			Character ss = modExpression.charAt(i);
			if (ss.equals('E')) {
				modExpression = AdvancedString.replaceCharAt(modExpression, i,
						"*10^");
			}

		}
		return modExpression;
	}

	static boolean isZnak(String ss) {
		for (int j = 0; j < znak.length; j++)
			if (ss.equals(znak[j]))
				return true;
		return false;
	}

	static boolean isBinZnak(String sh) {
		for (int j = 0; j < binznak.length; j++)
			if (sh.equals(binznak[j]))
				return true;
		return false;
	}

	static boolean isDigit(Character ss) {
		for (int j = 0; j < digit.length; j++){
			if (ss.toString().equals(digit[j])){
				return true;
			}
		}
		return false;
	}

	static int prior(char a) {
		switch (a) {
		case '#':
		case '!':
		case '@':
			return 5;
		case '^':
		case '$':
			return 4;
		case '*':
		case '/':
			return 3;
		case '-':
		case '+':
			return 2;
		case '(':
			return 1;
		}
		return 0;
	}

	static String translateToEasy(String expression) {
		String modExpression = new String(expression);
		serchDoubleZapis(expression);
		modExpression = modExpression.replace(" ", "");
		modExpression = modExpression.replace("cos", "!");
		modExpression = modExpression.replace("sin", "@");
		modExpression = modExpression.replace("pow", "$");
		modExpression = modExpression.replace(",", ".");
		modExpression = serchBinMinus(modExpression);
		return modExpression;
	}

	static ArrayList<String> translateToPN(String modExpression) throws unknownCharacterException{
		String number = "";
		Stack<Character> stack = new Stack<Character>();
		ArrayList<String> PNExpression = new ArrayList<String>();
		for (int i = 0; i < modExpression.length(); i++) {
			Character ss = modExpression.charAt(i);
			if (ss.equals('(')) {
				if (!number.equals("")) {
					PNExpression.add(number);
					number = "";
				}
				stack.push(ss);
				continue;
			} else if (ss.equals(')')) {
				if (!number.equals("")) {
					PNExpression.add(number);
					number = "";
				}
				while (!(stack.peek().equals('('))) {
					Character a = stack.pop();
					PNExpression.add(a.toString());
				}
				stack.pop();

				continue;

			} else if (isZnak(ss.toString())) {
				if (!number.equals("")) {
					PNExpression.add(number);
					number = "";
				}
				while (!(stack.empty()) && (prior(stack.peek()) >= prior(ss))) {
					Character a = stack.pop();
					PNExpression.add(a.toString());
					;
				}
				stack.push(ss);
			}

			else if (ss.equals(',')) {
				if (!number.equals("")) {
					PNExpression.add(number);
					number = "";
				}
			}

			else if (isDigit(ss)) {
				number += ss;
			}
			
			else throw new unknownCharacterException();
		}
		if (!number.equals("")) {
			PNExpression.add(number);
			number = "";
		}
		while (!stack.empty()) {
			Character a = stack.pop();
			PNExpression.add(a.toString());
		}

		return PNExpression;
	}

	public static Double rezult(ArrayList<String> PNExpression) {
		Double rez = null;
		Stack<Double> stack = new Stack<Double>();
		for (int i = 0; i < PNExpression.size(); i++) {
			String sh = PNExpression.get(i);
			if (!isZnak(sh)) {
				stack.push(Double.valueOf(sh));
			} else {
				if (isBinZnak(sh)) {
					Double op1 = stack.pop();
					switch (sh) {
					case "!":
						rez = Math.cos(op1);
						break;
					case "@":
						rez = Math.sin(op1);
						break;
					case "#":
						rez = 0 - op1;
						break;
					}
				} else {
					Double op1 = stack.pop();
					Double op2 = stack.pop();
					switch (sh) {
					case "+":
						rez = op2 + op1;
						break;
					case "-":
						rez = op2 - op1;
						break;
					case "*":
						rez = op2 * op1;
						break;
					case "/":
						rez = op2 / op1;
						break;
					case "^":
						rez = Math.pow(op2, op1);
						break;
					case "$":
						rez = Math.pow(op2, op1);
						break;
					case "#":
						rez = 0 - op1;
						break;
					}
				}
				stack.push(rez);
			}
		}
		return rez;
	}

	public static Double count(String expression) throws unknownCharacterException {
		return rezult(translateToPN(translateToEasy(expression)));
	}
}
