package Veiwer;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.JTextField;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import Calculator.CalculatorFunctions;
import Calculator.intervalException;
import Calculator.unknownCharacterException;
import Graph.GraphPanel;

public class GraphFrame extends JFrame {
	private JTextField functionTextField;
	private JTextField startTextField;
	private JTextField finishTextField;
	private JSlider stepSlider;
	private JButton startButton;
	private JPanel pg;
	private JLabel labelFun;
	private JLabel labelStart;
	private JLabel labelFinish;

	public GraphFrame(String str) {
		super(str);
		setLayout(new BorderLayout());
		setMinimumSize(new Dimension(700, 700));
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		pg = new GraphPanel();
		pg.setBorder(BorderFactory.createLineBorder(Color.GRAY, 2));
		add(pg, BorderLayout.CENTER);
		JPanel but = new JPanel();
		add(but, BorderLayout.NORTH);
		labelFun = new JLabel(":");
		functionTextField = new JTextField("x^2");
		functionTextField.setColumns(10);
		labelStart = new JLabel(" :");
		startTextField = new JTextField("-4");
		startTextField.setColumns(2);
		labelFinish = new JLabel(" :");
		finishTextField = new JTextField("4");
		finishTextField.setColumns(2);
		stepSlider = new JSlider(10, 100, 50);
		stepSlider.setMajorTickSpacing(10);
		stepSlider.setMinorTickSpacing(5);
		stepSlider.setLabelTable(stepSlider.createStandardLabels(10));
		stepSlider.setPaintTicks(true);
		stepSlider.setPaintLabels(true);
		startButton = new JButton(" ");
		but.add(labelFun);
		but.add(functionTextField);
		but.add(labelStart);
		but.add(startTextField);
		but.add(labelFinish);
		but.add(finishTextField);
		add(stepSlider, BorderLayout.SOUTH);

		stepSlider.addChangeListener(new ChangeListener() {
			@Override
			public void stateChanged(ChangeEvent e) {
				paint();
			}
		});
		but.add(startButton);
		startButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				paint();
			}
		});
		setLocationRelativeTo(null);
		setVisible(true);
	}

	void paint() {
		Double start = null;
		Double finish = null;
		try {
			start = Double.valueOf(startTextField.getText());
			finish = Double.valueOf(finishTextField.getText());
		} catch (Exception e3) {
			JOptionPane.showMessageDialog(null, "   .");
			return;
		}
		String fun = functionTextField.getText();
		Double step = (double) (stepSlider.getValue()) / 100;
		ArrayList<double[]> list;
		try {
			list = CalculatorFunctions.cout(fun, 'x', start, finish, step);
			((GraphPanel) pg).setList(list);
		} catch (unknownCharacterException e1) {
			JOptionPane.showMessageDialog(null,
					"   .");
		} catch (intervalException e4) {
			JOptionPane
					.showMessageDialog(null,
							"      ");
		} catch (Exception e2) {
			JOptionPane.showMessageDialog(null, "  .");
		}
	}

	public static void main(String[] args) {
		JFrame frame = new GraphFrame("");
	}
}
